interface Master {
    final static int VGA_PSET = 0;
    final static int TX_WHITE = 0;
    final static int TX_MAGENTA = 0;
    final static int TX_RED = 0;
    final static int TX_YELLOW = 0;
    final static int TX_GREEN = 0;
    final static int TX_CYAN = 0;
    final static int TX_REVERSE = 8;
    
    final static int K_CR = '\r';
    final static int K_ESC = '\033';
    final static int K_TAB = '\t';
    
    final static int SYS_BEEP_FREQ = 0;
    
    final static int NCOLOR = 16;

    /* for 'status' */
    final static int ST_NONE = 0;
    final static int ST_PAUSE = 1;
    final static int ST_JUGGLE = 2;
	
    final static int IMAGE_WIDTH = 480;
    final static int IMAGE_HEIGHT = 400;
    final static int HOR_CENTER = (IMAGE_WIDTH/2);
    final static int VER_CENTER = (IMAGE_HEIGHT/2);
}

