import java.awt.*;
import java.util.*;
import java.lang.*;

public class X11 extends java.applet.Applet implements Runnable, Master {
    public final static int PM_W = 32;
    public final static int PM_H = 24;
    public final static int DW = 290;

    int current_color = 0;

    Image image_pixmap;
    Graphics image_gc;
    int image_w, image_h;

    boolean menu_flag = true;

    Color color[] = {
	new Color(255, 255, 255),
	new Color(190, 190, 190),
	new Color(0, 0, 0),
	new Color(0, 255, 255),
	new Color(160, 32, 240),
	new Color(255, 0, 255),
	new Color(255, 192, 203),
	new Color(176, 48, 96),
	new Color(135, 206, 235),
	new Color(255, 127, 80),
	new Color(160, 82, 45),
	new Color(255, 165, 0),
	new Color(0, 255, 0),
	new Color(255, 255, 0),
	new Color(255, 0, 0),
	new Color(0, 0, 255)
    };

    Jm jm;
    Thread kicker = null;

    List select;
    Button juggle_button;
    Button pause_button;

    Label style_label;
    Label style_value;
    Label balls_label;
    Label balls_value;
    Label pattern_label;
    Label pattern_value;

    Label speed_label;
    Scrollbar speed_gauge;
    Label speed_value;
    Label height_label;
    Scrollbar height_gauge;
    Label height_value;
    Label dwell_label;
    Scrollbar dwell_gauge;
    Label dwell_value;
    Label interval_label;
    Scrollbar interval_gauge;
    Label interval_value;

    TextField text;

    void put_bm_x(Image bm[], Graphics bm_gc[], int x, int y){
	if(x < 0 || x > IMAGE_WIDTH - 32 || y < 0 || y > IMAGE_HEIGHT - 24){
	    return;
	}
//	XCopyArea(display, (Pixmap)bm[current_color], image_pixmap, gc,
//		  bm1,bm1, bm2-bm1+1, bm2-bm1+1, x+bm1, y+bm1);
/*
	image_gc.setClip(x + Extern.bm1,
			 y + Extern.bm1,
			 Extern.bm2 - Extern.bm1 + 1,
			 Extern.bm2 - Extern.bm1 + 1);
	image_gc.drawImage(bm[current_color], x, y, null);
	image_gc.setClip(0, 0, IMAGE_WIDTH, IMAGE_HEIGHT);
*/
	Graphics g = image_gc.create(x + Extern.bm1,
				     y + Extern.bm1,
				     Extern.bm2 - Extern.bm1 + 1,
				     Extern.bm2 - Extern.bm1 + 1);
	
	g.drawImage(bm[current_color], -Extern.bm1, -Extern.bm1, null);
	g.dispose();
    }
    void vgc_setcolor(int c){
	current_color = c;
	image_gc.setColor(color[c]);
    }
    void vtext_putsa(int x, int y, String str, int attrib){
	if ((attrib & TX_REVERSE) != 0){
	    image_gc.setColor(Color.red);
	    image_gc.drawString(str, x * 8, y * 16 + 16);
	}
	else {
	    image_gc.setColor(Color.black);
	    image_gc.drawString(str, x * 8, y * 16 + 16);
	}
    }
    void vgc_line(int x1, int y1, int x2, int y2){
	image_gc.drawLine(x1, y1, x2, y2);
    }
    void vgc_circle_x(int x, int y, int r){
	image_gc.drawArc(x - r, y - r, 2 * r, 2 * r, 0, 360);
    }
    void vgc_byteboxfill_x(int x1_b, int y1, int x2_b, int y2){
	image_gc.fillRect(x1_b * 8, y1, (x2_b - x1_b + 1) * 8, y2 - y1 + 1);
    }
    void xbitset(Image bm[], Image r_bm[], Image l_bm[],
		 Graphics bm_gc[], Graphics r_bm_gc[], Graphics l_bm_gc[]){
	int n;
	int i;
	int data[] = {
	    0,18, 0,23,17,23,20,22,
	    22,20,23,17,23,12,18,12,
	    18,16,16,18, 0,18,
	    12,15,23,17,99,99
	    };

	if (bm[0] == null){
	    for (n = 0; n < NCOLOR; n++){
		bm[n] = createImage(PM_W, PM_H);
		bm_gc[n] = bm[n].getGraphics();
		l_bm[n] = createImage(PM_W, PM_H);
		l_bm_gc[n] = l_bm[n].getGraphics();
		r_bm[n] = createImage(PM_W, PM_H);
		r_bm_gc[n] = r_bm[n].getGraphics();
	    }
	}
	for (n = 0; n < NCOLOR; n++){
	    bm_gc[n].setColor(Color.white);
	    bm_gc[n].fillRect(0, 0, PM_W, PM_H);
	    l_bm_gc[n].setColor(Color.white);
	    l_bm_gc[n].fillRect(0, 0, PM_W, PM_H);
	    r_bm_gc[n].setColor(Color.white);
	    r_bm_gc[n].fillRect(0, 0, PM_W, PM_H);
	}
	for (i = 0; data[i] < 99; i++){
	    data[i] = (data[i] - 11) * Extern.dpm / DW;
	}
	Extern.hand_x = data[i - 4] + 2;
	Extern.hand_y = data[i - 3] + 2;
	Extern.arm_x = data[i - 2];
	Extern.arm_y = data[i - 1];
	for (i = 0; data[i + 6] < 99; i += 2){
	    for (n = 0; n < NCOLOR; n++){
		r_bm_gc[n].setColor(color[n]);
		r_bm_gc[n].drawLine(
		    11 + data[i], 10 + data[i+1],
		    11 + data[i + 2],10 + data[i + 3]);
		l_bm_gc[n].setColor(color[n]);
		l_bm_gc[n].drawLine(
		    12 - data[i], 10 + data[i + 1],
		    12 - data[i + 2],10 + data[i + 3]);
	    }
	}
	int r = 11 * Extern.dpm / DW;
	for (n = 0; n < NCOLOR; n++){
	    bm_gc[n].setColor(color[n]);
	    bm_gc[n].fillArc(
		11 - r, 11 - r, 2 * r, 2 * r, 0, 360);

	}
	Extern.bm1 = 11 - 11 * Extern.dpm / DW;
	Extern.bm2 = 11 + 11 * Extern.dpm / DW + 1;
    }
    void gr_init(int menuflag){
	image_w = IMAGE_WIDTH;
	image_h = IMAGE_HEIGHT;
	if (menuflag != 0){
	    listTitleSelected(0);
	}
	else {
	    setLabels();
	}
	speed_value.setText(String.valueOf(jm.speed));
	speed_gauge.setValue((int)(jm.speed * 10));
	interval_value.setText(String.valueOf(jm.smode));
	interval_gauge.setValue((int)jm.smode);
    }
    void setLabels(){
	pattern_value.setText(jm.get_pbuf());
	balls_value.setText(String.valueOf(jm.get_balln()));
	height_value.setText(String.valueOf(jm.hr0));
	dwell_value.setText(String.valueOf(jm.dwell_ratio));
	style_value.setText(jm.styleName());
    }
    void listTitleSelected(int f){
	int i, ii;
	
	Extern.status = ST_NONE;
	if (f >= 0){
	    i = f;
	}
	else {
	    i = select.getSelectedIndex();
	}
	ii = jm.findPatternLine(i);
	select.select(ii);
	jm.setPatternInfo(ii);
	setLabels();
    }
    void x_all_clear(){
	vgc_setcolor(0);
	image_gc.fillRect(0, 0, image_w, image_h);
	getGraphics().drawImage(image_pixmap, 0, 0, null);
    }
    Graphics gg1, gg2;
    void gr_sync(Graphics g){
	if (g != null){
//	    XCopyArea(display, image_pixmap, image_win, gc_b,
//		      0,0, image_w, 20,
//		      0,0);
/*
	    g.setClip(0, 0, image_w, 20);
	    g.drawImage(image_pixmap, 0, 0, null);
*/
//	    XCopyArea(display, image_pixmap, image_win, gc_b,
//		      gx_min,0, gx_max-gx_min+1, image_h,
//		      gx_min,0);
/*
	    g.setClip(Extern.gx_min, 0,
		      Extern.gx_max - Extern.gx_min + 1, image_h);
	    g.drawImage(image_pixmap, 0, 0, null);
*/
	    if (gg1 != null){
		gg1.drawImage(image_pixmap, 0, 0, null);
	    }
	    if (gg2 != null){
		gg2.drawImage(image_pixmap, -Extern.gx_min, 0, null);
	    }
	}
	else {
	    g = getGraphics();
	    if (gg1 != null){
		gg1.dispose();
	    }
	    gg1 = g.create(0, 0, image_w, 20);
	    if (gg2 != null){
		gg2.dispose();
	    }
	    gg2 = g.create(Extern.gx_min, 0,
			   Extern.gx_max - Extern.gx_min + 1, image_h);
	    g.dispose();
	}
    }
    void vga_vsync_start(){
	if (kicker == null){
	    kicker = new Thread(this);
	    kicker.start();
	}
    }
    void setPatternTitles(CharPointer pp[], int n){
	CharPointer p;
	String s;
	int i;

	for (i = 0; i < n; i++){
	    p = pp[i];
	    s = String.valueOf(p.getPointer(), p.getIndex(), p.strlen());
	    select.addItem(s);
	}
    }
    public void init(){
	setLayout(null);
	setBackground(Color.white);

	select = new List();
	select.reshape(280, 400, 200, 210); // setBounds(,,,);
	add(select);

	juggle_button = new Button("juggle");
	juggle_button.reshape(0, 400, 93, 30);
	add(juggle_button);

	pause_button = new Button("pause");
	pause_button.reshape(93, 400, 93, 30);
	add(pause_button);


	style_label = new Label("style");
	style_label.reshape(0, 440, 93, 20);
	add(style_label);

	style_value = new Label("");
	style_value.reshape(93, 440, 186, 20);
	add(style_value);

	balls_label = new Label("balls");
	balls_label.reshape(0, 460, 93, 20);
	add(balls_label);

	balls_value = new Label("");
	balls_value.reshape(93, 460, 93, 20);
	add(balls_value);

	pattern_label = new Label("pattern");
	pattern_label.reshape(0, 480, 93, 20);
	add(pattern_label);

	pattern_value = new Label("");
	pattern_value.reshape(93, 480, 186, 20);
	add(pattern_value);



	speed_label = new Label("speed");
	speed_label.reshape(0, 510, 93, 20);
	add(speed_label);

	speed_gauge = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 1, 20 + 1);
	speed_gauge.reshape(93, 510, 93, 20);
	add(speed_gauge);

	speed_value = new Label("");
	speed_value.reshape(186, 510, 93, 20);
	add(speed_value);

	height_label = new Label("height");
	height_label.reshape(0, 530, 93, 20);
	add(height_label);

	height_gauge = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 1, 100 + 1);
	height_gauge.reshape(93, 530, 93, 20);
	add(height_gauge);

	height_value = new Label("");
	height_value.reshape(186, 530, 93, 20);
	add(height_value);

	dwell_label = new Label("dwell");
	dwell_label.reshape(0, 550, 93, 20);
	add(dwell_label);

	dwell_gauge = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 10, 90 + 1);
	dwell_gauge.reshape(93, 550, 93, 20);
	add(dwell_gauge);

	dwell_value = new Label("");
	dwell_value.reshape(186, 550, 93, 20);
	add(dwell_value);

	interval_label = new Label("interval");
	interval_label.reshape(0, 570, 93, 20);
	add(interval_label);

	interval_gauge =  new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 2, 99 + 1);
	interval_gauge.reshape(93, 570, 93, 20);
	add(interval_gauge);

	interval_value = new Label("");
	interval_value.reshape(183, 570, 93, 20);
	add(interval_value);

	text = new TextField();
	text.reshape(0, 600, 280, 30);
	add(text);

	jm_start();
        image_pixmap = createImage(IMAGE_WIDTH, IMAGE_HEIGHT);
	image_gc = image_pixmap.getGraphics();
    }
    void setText(String s){
	text.setText(s);
    }
    String getText(){
	return text.getText();
    }
    boolean main_flag = false;
    void jm_start(){
	jm = new Jm(this);
        main_flag = jm.jm_main();
    }
    public void run(){
	while (kicker != null){
	    if (main_flag){
		jm.do_juggle();
		jm.count_up_timer();
	    }
	    try {
		kicker.sleep((int)(1000 / jm.smode));
	    }
	    catch (InterruptedException e){
	    }
	}
    }
    public boolean handleEvent(Event e){
	if (e.target == speed_gauge){
	    speed_pressed();
	    return true;
	}
	if (e.target == height_gauge){
	    height_pressed();
	    return true;
	}
	if (e.target == dwell_gauge){
	    dwell_pressed();
	    return true;
	}
	if (e.target == interval_gauge){
	    interval_pressed();
	    return true;
	}
	if (e.target == select && e.id == Event.LIST_SELECT){
	    listTitleSelected(-1);
	}
	return super.handleEvent(e);
    }
    public boolean action(Event e, Object obj){
        if (e.target == select){
	    listTitleSelected(-1);
	    jug_pressed();
	    return true;
        }
	if (e.target == juggle_button){
	    jug_pressed();
	    return true;
	}
	if (e.target == pause_button){
	    Extern.status = (Extern.status == ST_NONE ? ST_NONE :
		      Extern.status == ST_PAUSE ? ST_JUGGLE : ST_PAUSE);
	    return true;
	}
	if (e.target == text){
	    if (kicker != null){
		kicker.stop();
		kicker = null;
	    }
	    select.clear();
	    Graphics g = getGraphics();
	    g.setColor(Color.white);
	    g.fillRect(0, 0, image_w, image_h);
	    jm_start();
	    return true;

	}
        return super.action(e, obj);
    }
    void jug_pressed(){
	if (main_flag){
	    x_all_clear();
	    jm.jug_start();
	    Extern.status = ST_JUGGLE;
	}
    }
    void speed_pressed(){
	int val;

	val = speed_gauge.getValue();
	jm.speed = val / 10f;
	speed_value.setText(String.valueOf(jm.speed));
    }
    void height_pressed(){
	int val;

	val = height_gauge.getValue();
	jm.hr0 = val / 100f;
	height_value.setText(String.valueOf(jm.hr0));
    }
    void dwell_pressed(){
	int val;

	val = dwell_gauge.getValue();
	jm.dwell_ratio = val / 100f;
	dwell_value.setText(String.valueOf(jm.dwell_ratio));
    }
    void interval_pressed(){
	int val;

	val = interval_gauge.getValue();
	jm.smode = val / 1f;
	interval_value.setText(String.valueOf(jm.smode));
    }
    public void update(Graphics g){
	paint(g);
    }
    public void paint(Graphics g){
	gr_sync(g);
    }
}
